#ifndef included_hicn_api_types_h
#define included_hicn_api_types_h
#define VL_API_HICN_API_VERSION_MAJOR 5
#define VL_API_HICN_API_VERSION_MINOR 1
#define VL_API_HICN_API_VERSION_PATCH 0
/* Imported API files */
#include <vnet/ip/ip_types.api_types.h>
typedef enum {
    HICN_DISABLE = 0,
    HICN_ENABLE = 1,
} vl_api_hicn_action_type_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_face {
    vl_api_address_t nat_addr;
    u32 swif;
    u32 flags;
    u8 if_name[30];
} vl_api_hicn_face_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_node_params_set {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 enable_disable;
    i32 pit_max_size;
    i32 cs_max_size;
    f64 pit_max_lifetime_sec;
} vl_api_hicn_api_node_params_set_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_node_params_set_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_hicn_api_node_params_set_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_node_params_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_hicn_api_node_params_get_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_node_params_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 is_enabled;
    u8 feature_cs;
    u32 worker_count;
    u32 pit_max_size;
    u32 cs_max_size;
    f64 pit_max_lifetime_sec;
} vl_api_hicn_api_node_params_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_node_stats_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_hicn_api_node_stats_get_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_node_stats_get_reply {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    i32 retval;
    u64 pkts_processed;
    u64 pkts_interest_count;
    u64 pkts_data_count;
    u64 pkts_from_cache_count;
    u64 pkts_no_pit_count;
    u64 pit_expired_count;
    u64 cs_expired_count;
    u64 cs_lru_count;
    u64 pkts_drop_no_buf;
    u64 interests_aggregated;
    u64 interests_retx;
    u64 interests_hash_collision;
    u64 pit_entries_count;
    u64 cs_entries_count;
    u64 cs_entries_ntw_count;
} vl_api_hicn_api_node_stats_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_face_stats_details {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 faceid;
    u64 irx_packets;
    u64 irx_bytes;
    u64 itx_packets;
    u64 itx_bytes;
    u64 drx_packets;
    u64 drx_bytes;
    u64 dtx_packets;
    u64 dtx_bytes;
} vl_api_hicn_api_face_stats_details_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_face_stats_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_hicn_api_face_stats_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_face_params_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 faceid;
} vl_api_hicn_api_face_params_get_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_face_params_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 faceid;
    vl_api_address_t nat_addr;
    u32 swif;
    u32 flags;
} vl_api_hicn_api_face_params_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_faces_details {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 faceid;
    vl_api_hicn_face_t face;
} vl_api_hicn_api_faces_details_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_faces_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_hicn_api_faces_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_face_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 faceid;
} vl_api_hicn_api_face_get_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_face_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 faceid;
    vl_api_hicn_face_t face;
} vl_api_hicn_api_face_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_route_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_prefix_t prefix;
} vl_api_hicn_api_route_get_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_route_get_reply {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 faceids[5];
    u8 nfaces;
    u32 strategy_id;
    i32 retval;
} vl_api_hicn_api_route_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_routes_details {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_prefix_t prefix;
    u32 faceids[5];
    u8 nfaces;
    u32 strategy_id;
    i32 retval;
} vl_api_hicn_api_routes_details_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_routes_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_hicn_api_routes_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_strategies_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_hicn_api_strategies_get_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_strategies_get_reply {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 n_strategies;
    u32 strategy_id[256];
    i32 retval;
} vl_api_hicn_api_strategies_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_strategy_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 strategy_id;
} vl_api_hicn_api_strategy_get_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_strategy_get_reply {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 description[200];
    i32 retval;
} vl_api_hicn_api_strategy_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_hicn_action_type_t enable_disable;
    vl_api_prefix_t prefix;
} vl_api_hicn_api_enable_disable_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_enable_disable_reply {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    i32 retval;
} vl_api_hicn_api_enable_disable_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_register_prod_app {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_prefix_t prefix;
    u32 swif;
    u32 cs_reserved;
} vl_api_hicn_api_register_prod_app_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_register_prod_app_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 cs_reserved;
    vl_api_address_t prod_addr;
    u32 faceid;
} vl_api_hicn_api_register_prod_app_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_face_prod_del {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 faceid;
} vl_api_hicn_api_face_prod_del_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_face_prod_del_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_hicn_api_face_prod_del_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_register_cons_app {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 swif;
} vl_api_hicn_api_register_cons_app_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_register_cons_app_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    vl_api_address_t src_addr4;
    vl_api_address_t src_addr6;
    u32 faceid1;
    u32 faceid2;
} vl_api_hicn_api_register_cons_app_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_face_cons_del {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 faceid;
} vl_api_hicn_api_face_cons_del_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_face_cons_del_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_hicn_api_face_cons_del_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_udp_tunnel_add_del {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_address_t src_addr;
    vl_api_address_t dst_addr;
    u16 src_port;
    u16 dst_port;
    u8 is_add;
} vl_api_hicn_api_udp_tunnel_add_del_t;
typedef struct __attribute__ ((packed)) _vl_api_hicn_api_udp_tunnel_add_del_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 uei;
} vl_api_hicn_api_udp_tunnel_add_del_reply_t;
#define VL_API_HICN_API_NODE_PARAMS_SET_CRC "hicn_api_node_params_set_e8ab8343"
#define VL_API_HICN_API_NODE_PARAMS_SET_REPLY_CRC "hicn_api_node_params_set_reply_e8d4e804"
#define VL_API_HICN_API_NODE_PARAMS_GET_CRC "hicn_api_node_params_get_51077d14"
#define VL_API_HICN_API_NODE_PARAMS_GET_REPLY_CRC "hicn_api_node_params_get_reply_16f5d026"
#define VL_API_HICN_API_NODE_STATS_GET_CRC "hicn_api_node_stats_get_51077d14"
#define VL_API_HICN_API_NODE_STATS_GET_REPLY_CRC "hicn_api_node_stats_get_reply_6b38e79b"
#define VL_API_HICN_API_FACE_STATS_DETAILS_CRC "hicn_api_face_stats_details_16c80415"
#define VL_API_HICN_API_FACE_STATS_DUMP_CRC "hicn_api_face_stats_dump_51077d14"
#define VL_API_HICN_API_FACE_PARAMS_GET_CRC "hicn_api_face_params_get_ab295484"
#define VL_API_HICN_API_FACE_PARAMS_GET_REPLY_CRC "hicn_api_face_params_get_reply_1680ab90"
#define VL_API_HICN_API_FACES_DETAILS_CRC "hicn_api_faces_details_79f8efa8"
#define VL_API_HICN_API_FACES_DUMP_CRC "hicn_api_faces_dump_51077d14"
#define VL_API_HICN_API_FACE_GET_CRC "hicn_api_face_get_ab295484"
#define VL_API_HICN_API_FACE_GET_REPLY_CRC "hicn_api_face_get_reply_79f8efa8"
#define VL_API_HICN_API_ROUTE_GET_CRC "hicn_api_route_get_c2bba878"
#define VL_API_HICN_API_ROUTE_GET_REPLY_CRC "hicn_api_route_get_reply_25931609"
#define VL_API_HICN_API_ROUTES_DETAILS_CRC "hicn_api_routes_details_9befde5e"
#define VL_API_HICN_API_ROUTES_DUMP_CRC "hicn_api_routes_dump_51077d14"
#define VL_API_HICN_API_STRATEGIES_GET_CRC "hicn_api_strategies_get_51077d14"
#define VL_API_HICN_API_STRATEGIES_GET_REPLY_CRC "hicn_api_strategies_get_reply_ca33692b"
#define VL_API_HICN_API_STRATEGY_GET_CRC "hicn_api_strategy_get_4d3ebf01"
#define VL_API_HICN_API_STRATEGY_GET_REPLY_CRC "hicn_api_strategy_get_reply_8b59590a"
#define VL_API_HICN_API_ENABLE_DISABLE_CRC "hicn_api_enable_disable_156e74bc"
#define VL_API_HICN_API_ENABLE_DISABLE_REPLY_CRC "hicn_api_enable_disable_reply_4db5150e"
#define VL_API_HICN_API_REGISTER_PROD_APP_CRC "hicn_api_register_prod_app_31c5278a"
#define VL_API_HICN_API_REGISTER_PROD_APP_REPLY_CRC "hicn_api_register_prod_app_reply_0316ff50"
#define VL_API_HICN_API_FACE_PROD_DEL_CRC "hicn_api_face_prod_del_ab295484"
#define VL_API_HICN_API_FACE_PROD_DEL_REPLY_CRC "hicn_api_face_prod_del_reply_e8d4e804"
#define VL_API_HICN_API_REGISTER_CONS_APP_CRC "hicn_api_register_cons_app_12ac291d"
#define VL_API_HICN_API_REGISTER_CONS_APP_REPLY_CRC "hicn_api_register_cons_app_reply_a6a1666e"
#define VL_API_HICN_API_FACE_CONS_DEL_CRC "hicn_api_face_cons_del_ab295484"
#define VL_API_HICN_API_FACE_CONS_DEL_REPLY_CRC "hicn_api_face_cons_del_reply_e8d4e804"
#define VL_API_HICN_API_UDP_TUNNEL_ADD_DEL_CRC "hicn_api_udp_tunnel_add_del_68caaa87"
#define VL_API_HICN_API_UDP_TUNNEL_ADD_DEL_REPLY_CRC "hicn_api_udp_tunnel_add_del_reply_5b8140c3"

#endif
